#ifndef MD5_H
#define MD5_H

#include "text_t.h"

#ifdef __alpha
typedef unsigned int uint32;
#else
typedef unsigned long uint32;
#endif

struct MD5Context {
  uint32 buf[4];
  uint32 bits[2];
  unsigned char in[64];
};

void MD5Init(MD5Context *ctx);
void MD5Update(MD5Context *ctx, unsigned char *buf, unsigned int len);
void MD5Final(unsigned char digest[16], MD5Context *ctx);
void MD5Transform(uint32 buf[4], uint32 in[16]);

text_t md5data(const text_t &data);

#endif
